﻿Imports ThinkGeo.MapSuite.Drawing
Imports ThinkGeo.MapSuite.Layers
Imports ThinkGeo.MapSuite.Shapes
Imports ThinkGeo.MapSuite.Styles
Imports ThinkGeo.MapSuite.WinForms

Public Class Form1
	Dim mLayerOverlay As LayerOverlay
	Private Sub Form1_Load(sender As Object, e As System.EventArgs) Handles Me.Load
		Dim oGoogle As New CustomGoogleMapsLayer

		Dim oProj4 As New Proj4Projection
		With oProj4
			.InternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString '   GetProjParameterString(EnumCoordSys.Spherical_Mercator)
			.ExternalProjectionParametersString = Proj4Projection.GetEsriParametersString(102003) ' SpatialReference.GetProjParameterString(Map.CoordSysInfo.SRID)
			oProj4.Open()
			oGoogle.ProjectionFromSphericalMercator = oProj4
		End With


		oGoogle.MapType = ThinkGeo.MapSuite.Layers.GoogleMapsMapType.Hybrid
		Dim oOverLay As New LayerOverlay
		oOverLay.Layers.Add(oGoogle)
		WinformsMap1.MapUnit = ThinkGeo.MapSuite.GeographyUnit.Meter
		WinformsMap1.Overlays.Add(oOverLay)
		WinformsMap1.Refresh()

	End Sub

	Private Sub btnOpen_Click(sender As Object, e As System.EventArgs) Handles btnOpen.Click
		Dim sFileName As String
		Dim oDlg As New OpenFileDialog
		Dim oGpxShapeLayer As New GpxFeatureLayer

		With oDlg
			.Filter = "GPX Files (*.gpx)|*.gpx"
			.InitialDirectory = "..\..\Data"
			If .ShowDialog() = Windows.Forms.DialogResult.Cancel Then
				Return
			End If
			sFileName = .FileName
		End With

		oGpxShapeLayer = New GpxFeatureLayer(sFileName)
		Dim pointStyle As New ValueStyle()
		pointStyle.ColumnName = "IsWayPoint"
		pointStyle.ValueItems.Add(New ValueItem("0", PointStyles.CreateSimplePointStyle(PointSymbolType.Circle, GeoColor.SimpleColors.Red, 4)))
		pointStyle.ValueItems.Add(New ValueItem("1", PointStyles.CreateSimplePointStyle(PointSymbolType.Circle, GeoColor.SimpleColors.Green, 8)))
		Dim roadstyle As LineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.SimpleColors.Black, 1, True)

		oGpxShapeLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(pointStyle)
		oGpxShapeLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(roadstyle)
		oGpxShapeLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20

		'Dim textLayer As New GpxFeatureLayer(sFileName)
		'Dim labelStyle As TextStyle = TextStyles.CreateSimpleTextStyle("name", "Arial", 8, DrawingFontStyles.Bold, GeoColor.SimpleColors.Black)
		'labelStyle.PointPlacement = PointPlacement.UpperCenter
		'labelStyle.OverlappingRule = LabelOverlappingRule.NoOverlapping
		'labelStyle.YOffsetInPixel = 8

		'textLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(labelStyle)
		'textLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20

		'Dim worldMapKitfOverlay As New WorldMapKitWmsDesktopOverlay
		'WinformsMap1.Overlays.Add(worldMapKitfOverlay)

		If mLayerOverlay Is Nothing Then
			mLayerOverlay = New LayerOverlay
		End If
		mLayerOverlay.Layers.Clear()

		mLayerOverlay.Layers.Add(oGpxShapeLayer)
		'layerOverlay.Layers.Add(textLayer)
		WinformsMap1.Overlays.Add(mLayerOverlay)

		oGpxShapeLayer.Open()
		WinformsMap1.CurrentExtent = oGpxShapeLayer.GetBoundingBox()

		WinformsMap1.Refresh()
		Dim oFeature As Feature
		Dim oFeatures = oGpxShapeLayer.QueryTools.GetAllFeatures(ReturningColumnsType.AllColumns)
		For Each oFeature In oFeatures
			Debug.WriteLine("Shape type is " & oFeature.GetWellKnownType.ToString)
		Next oFeature





	End Sub
End Class
